<center><a href="bcgs.c">Actual source code: bcgs.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:29:14+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCKSP_DLL</font></strong>

<a name="line3"> 3: </a> #include <A href="../../../../../src/ksp/ksp/kspimpl.h.html">src/ksp/ksp/kspimpl.h</A>

<a name="line7">  7: </a><strong><font color="#4169E1"><a name="KSPSetUp_BCGS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> KSPSetUp_BCGS(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp)</font></strong>
<a name="line8">  8: </a>{

<a name="line12"> 12: </a>  <font color="#4169E1">if</font> (ksp-&gt;pc_side == PC_SYMMETRIC) {
<a name="line13"> 13: </a>    <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_SUP,<font color="#666666">"no symmetric preconditioning for <A href="../../../../../docs/manualpages/KSP/KSPBCGS.html#KSPBCGS">KSPBCGS</A>"</font>);
<a name="line14"> 14: </a>  }
<a name="line15"> 15: </a>  KSPDefaultGetWork(ksp,6);
<a name="line16"> 16: </a>  <font color="#4169E1">return</font>(0);
<a name="line17"> 17: </a>}

<a name="line21"> 21: </a><strong><font color="#4169E1"><a name="KSPSolve_BCGS"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  KSPSolve_BCGS(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp)</font></strong>
<a name="line22"> 22: </a>{
<a name="line24"> 24: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i;
<a name="line25"> 25: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    rho,rhoold,alpha,beta,omega,omegaold,d1,d2;
<a name="line26"> 26: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            X,B,V,P,R,RP,T,S;
<a name="line27"> 27: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      dp = 0.0;


<a name="line31"> 31: </a>  X       = ksp-&gt;vec_sol;
<a name="line32"> 32: </a>  B       = ksp-&gt;vec_rhs;
<a name="line33"> 33: </a>  R       = ksp-&gt;work[0];
<a name="line34"> 34: </a>  RP      = ksp-&gt;work[1];
<a name="line35"> 35: </a>  V       = ksp-&gt;work[2];
<a name="line36"> 36: </a>  T       = ksp-&gt;work[3];
<a name="line37"> 37: </a>  S       = ksp-&gt;work[4];
<a name="line38"> 38: </a>  P       = ksp-&gt;work[5];

<a name="line40"> 40: </a>  <font color="#B22222">/* Compute initial preconditioned residual */</font>
<a name="line41"> 41: </a> <A href="../../../../../docs/manualpages/KSP/KSPInitialResidual.html#KSPInitialResidual">KSPInitialResidual</A>(ksp,X,V,T,R,B);

<a name="line43"> 43: </a>  <font color="#B22222">/* Test for nothing to do */</font>
<a name="line44"> 44: </a>  <font color="#4169E1">if</font> (ksp-&gt;normtype != <A href="../../../../../docs/manualpages/KSP/KSP_NO_NORM.html#KSP_NO_NORM">KSP_NO_NORM</A>) {
<a name="line45"> 45: </a>    <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(R,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;dp);
<a name="line46"> 46: </a>  }
<a name="line47"> 47: </a>  PetscObjectTakeAccess(ksp);
<a name="line48"> 48: </a>  ksp-&gt;its   = 0;
<a name="line49"> 49: </a>  ksp-&gt;rnorm = dp;
<a name="line50"> 50: </a>  PetscObjectGrantAccess(ksp);
<a name="line51"> 51: </a>  KSPLogResidualHistory(ksp,dp);
<a name="line52"> 52: </a>  KSPMonitor(ksp,0,dp);
<a name="line53"> 53: </a>  (*ksp-&gt;converged)(ksp,0,dp,&amp;ksp-&gt;reason,ksp-&gt;cnvP);
<a name="line54"> 54: </a>  <font color="#4169E1">if</font> (ksp-&gt;reason) <font color="#4169E1">return</font>(0);

<a name="line56"> 56: </a>  <font color="#B22222">/* Make the initial Rp == R */</font>
<a name="line57"> 57: </a>  <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(R,RP);

<a name="line59"> 59: </a>  rhoold   = 1.0;
<a name="line60"> 60: </a>  alpha    = 1.0;
<a name="line61"> 61: </a>  omegaold = 1.0;
<a name="line62"> 62: </a>  <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(P,0.0);
<a name="line63"> 63: </a>  <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(V,0.0);

<a name="line65"> 65: </a>  i=0;
<a name="line66"> 66: </a>  <font color="#4169E1">do</font> {
<a name="line67"> 67: </a>    <A href="../../../../../docs/manualpages/Vec/VecDot.html#VecDot">VecDot</A>(R,RP,&amp;rho);       <font color="#B22222">/*   rho &lt;- (r,rp)      */</font>
<a name="line68"> 68: </a>    <font color="#4169E1">if</font> (rho == 0.0) {
<a name="line69"> 69: </a>      ksp-&gt;reason = <A href="../../../../../docs/manualpages/KSP/KSP_DIVERGED_BREAKDOWN.html#KSP_DIVERGED_BREAKDOWN">KSP_DIVERGED_BREAKDOWN</A>;
<a name="line70"> 70: </a>      <font color="#4169E1">break</font>;
<a name="line71"> 71: </a>    }
<a name="line72"> 72: </a>    beta = (rho/rhoold) * (alpha/omegaold);
<a name="line73"> 73: </a>    <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(P,-omegaold,V);         <font color="#B22222">/*   p &lt;- p - w v       */</font>
<a name="line74"> 74: </a>    <A href="../../../../../docs/manualpages/Vec/VecAYPX.html#VecAYPX">VecAYPX</A>(P,beta,R);      <font color="#B22222">/*   p &lt;- r + p beta    */</font>
<a name="line75"> 75: </a>    KSP_PCApplyBAorAB(ksp,P,V,T);  <font color="#B22222">/*   v &lt;- K p           */</font>
<a name="line76"> 76: </a>    <A href="../../../../../docs/manualpages/Vec/VecDot.html#VecDot">VecDot</A>(V,RP,&amp;d1);
<a name="line77"> 77: </a>    alpha = rho / d1;                 <font color="#B22222">/*   a &lt;- rho / (v,rp)  */</font>
<a name="line78"> 78: </a>    <A href="../../../../../docs/manualpages/Vec/VecWAXPY.html#VecWAXPY">VecWAXPY</A>(S,-alpha,V,R);      <font color="#B22222">/*   s &lt;- r - a v       */</font>
<a name="line79"> 79: </a>    KSP_PCApplyBAorAB(ksp,S,T,R);<font color="#B22222">/*   t &lt;- K s    */</font>
<a name="line80"> 80: </a>    <A href="../../../../../docs/manualpages/Vec/VecDot.html#VecDot">VecDot</A>(S,T,&amp;d1);
<a name="line81"> 81: </a>    <A href="../../../../../docs/manualpages/Vec/VecDot.html#VecDot">VecDot</A>(T,T,&amp;d2);
<a name="line82"> 82: </a>    <font color="#4169E1">if</font> (d2 == 0.0) {
<a name="line83"> 83: </a>      <font color="#B22222">/* t is 0.  if s is 0, then alpha v == r, and hence alpha p</font>
<a name="line84"> 84: </a><font color="#B22222">         may be our solution.  Give it a try? */</font>
<a name="line85"> 85: </a>      <A href="../../../../../docs/manualpages/Vec/VecDot.html#VecDot">VecDot</A>(S,S,&amp;d1);
<a name="line86"> 86: </a>      <font color="#4169E1">if</font> (d1 == 0.0) {
<a name="line87"> 87: </a>        ksp-&gt;reason = <A href="../../../../../docs/manualpages/KSP/KSP_DIVERGED_BREAKDOWN.html#KSP_DIVERGED_BREAKDOWN">KSP_DIVERGED_BREAKDOWN</A>;
<a name="line88"> 88: </a>        <font color="#4169E1">break</font>;
<a name="line89"> 89: </a>      }
<a name="line90"> 90: </a>      <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(X,alpha,P);   <font color="#B22222">/*   x &lt;- x + a p       */</font>
<a name="line91"> 91: </a>      PetscObjectTakeAccess(ksp);
<a name="line92"> 92: </a>      ksp-&gt;its++;
<a name="line93"> 93: </a>      ksp-&gt;rnorm  = 0.0;
<a name="line94"> 94: </a>      ksp-&gt;reason = <A href="../../../../../docs/manualpages/KSP/KSP_CONVERGED_RTOL.html#KSP_CONVERGED_RTOL">KSP_CONVERGED_RTOL</A>;
<a name="line95"> 95: </a>      PetscObjectGrantAccess(ksp);
<a name="line96"> 96: </a>      KSPLogResidualHistory(ksp,dp);
<a name="line97"> 97: </a>      KSPMonitor(ksp,i+1,0.0);
<a name="line98"> 98: </a>      <font color="#4169E1">break</font>;
<a name="line99"> 99: </a>    }
<a name="line100">100: </a>    omega = d1 / d2;                               <font color="#B22222">/*   w &lt;- (t's) / (t't) */</font>
<a name="line101">101: </a>    <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(X,alpha,P);     <font color="#B22222">/*   x &lt;- x + a p       */</font>
<a name="line102">102: </a>    <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(X,omega,S);     <font color="#B22222">/*   x &lt;- x + w s       */</font>
<a name="line103">103: </a>    <A href="../../../../../docs/manualpages/Vec/VecWAXPY.html#VecWAXPY">VecWAXPY</A>(R,-omega,T,S);     <font color="#B22222">/*   r &lt;- s - w t       */</font>
<a name="line104">104: </a>    <font color="#4169E1">if</font> (ksp-&gt;normtype != <A href="../../../../../docs/manualpages/KSP/KSP_NO_NORM.html#KSP_NO_NORM">KSP_NO_NORM</A>) {
<a name="line105">105: </a>      <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(R,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;dp);
<a name="line106">106: </a>    }

<a name="line108">108: </a>    rhoold   = rho;
<a name="line109">109: </a>    omegaold = omega;

<a name="line111">111: </a>    PetscObjectTakeAccess(ksp);
<a name="line112">112: </a>    ksp-&gt;its++;
<a name="line113">113: </a>    ksp-&gt;rnorm = dp;
<a name="line114">114: </a>    PetscObjectGrantAccess(ksp);
<a name="line115">115: </a>    KSPLogResidualHistory(ksp,dp);
<a name="line116">116: </a>    KSPMonitor(ksp,i+1,dp);
<a name="line117">117: </a>    (*ksp-&gt;converged)(ksp,i+1,dp,&amp;ksp-&gt;reason,ksp-&gt;cnvP);
<a name="line118">118: </a>    <font color="#4169E1">if</font> (ksp-&gt;reason) <font color="#4169E1">break</font>;
<a name="line119">119: </a>    i++;
<a name="line120">120: </a>  } <font color="#4169E1">while</font> (i&lt;ksp-&gt;max_it);

<a name="line122">122: </a>  <font color="#4169E1">if</font> (i &gt;= ksp-&gt;max_it) {
<a name="line123">123: </a>    ksp-&gt;reason = <A href="../../../../../docs/manualpages/KSP/KSP_DIVERGED_ITS.html#KSP_DIVERGED_ITS">KSP_DIVERGED_ITS</A>;
<a name="line124">124: </a>  }

<a name="line126">126: </a>  <A href="../../../../../docs/manualpages/KSP/KSPUnwindPreconditioner.html#KSPUnwindPreconditioner">KSPUnwindPreconditioner</A>(ksp,X,T);
<a name="line127">127: </a>  <font color="#4169E1">return</font>(0);
<a name="line128">128: </a>}

<a name="line130">130: </a><font color="#B22222">/*MC</font>
<a name="line131">131: </a><font color="#B22222">     <A href="../../../../../docs/manualpages/KSP/KSPBCGS.html#KSPBCGS">KSPBCGS</A> - Implements the BiCGStab (Stabilized version of BiConjugate Gradient Squared) method.</font>

<a name="line133">133: </a><font color="#B22222">   Options Database Keys:</font>
<a name="line134">134: </a><font color="#B22222">.   see <A href="../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>()</font>

<a name="line136">136: </a><font color="#B22222">   Level: beginner</font>

<a name="line138">138: </a><font color="#B22222">   Notes: Reference: van der Vorst, SIAM J. Sci. Stat. Comput., 1992.</font>
<a name="line139">139: </a><font color="#B22222">          See <A href="../../../../../docs/manualpages/KSP/KSPBCGSL.html#KSPBCGSL">KSPBCGSL</A> for additional stabilization</font>

<a name="line141">141: </a><font color="#B22222">.seealso:  <A href="../../../../../docs/manualpages/KSP/KSPCreate.html#KSPCreate">KSPCreate</A>(), <A href="../../../../../docs/manualpages/KSP/KSPSetType.html#KSPSetType">KSPSetType</A>(), <A href="../../../../../docs/manualpages/KSP/KSPType.html#KSPType">KSPType</A> (for list of available types), <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>, <A href="../../../../../docs/manualpages/KSP/KSPBICG.html#KSPBICG">KSPBICG</A>, <A href="../../../../../docs/manualpages/KSP/KSPBCGSL.html#KSPBCGSL">KSPBCGSL</A></font>
<a name="line142">142: </a><font color="#B22222">M*/</font>
<a name="line146">146: </a><strong><font color="#4169E1"><a name="KSPCreate_BCGS"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  KSPCreate_BCGS(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp)</font></strong>
<a name="line147">147: </a>{
<a name="line149">149: </a>  ksp-&gt;data                 = (void*)0;
<a name="line150">150: </a>  ksp-&gt;pc_side              = PC_LEFT;
<a name="line151">151: </a>  ksp-&gt;ops-&gt;setup           = KSPSetUp_BCGS;
<a name="line152">152: </a>  ksp-&gt;ops-&gt;solve           = KSPSolve_BCGS;
<a name="line153">153: </a>  ksp-&gt;ops-&gt;destroy         = KSPDefaultDestroy;
<a name="line154">154: </a>  ksp-&gt;ops-&gt;buildsolution   = KSPDefaultBuildSolution;
<a name="line155">155: </a>  ksp-&gt;ops-&gt;buildresidual   = KSPDefaultBuildResidual;
<a name="line156">156: </a>  ksp-&gt;ops-&gt;setfromoptions  = 0;
<a name="line157">157: </a>  ksp-&gt;ops-&gt;view            = 0;
<a name="line158">158: </a>  <font color="#4169E1">return</font>(0);
<a name="line159">159: </a>}
</pre>
</body>

</html>
